package com.StudentServices.MarksService.controller;

import com.StudentServices.MarksService.model.StudentMarks;
import com.StudentServices.MarksService.service.StudentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@CrossOrigin(origins = "*")
@RestController
@RequestMapping("/api/")

public class StudentMarksController {

    @Autowired StudentService studentService;

    // (GET) findall studentmarks
    @GetMapping("/studentMarks")
    ResponseEntity<List<StudentMarks>> findAllStudentMarks(){
        return ResponseEntity.ok(studentService.findAllStudents());
    }
    // (POST) create studentmark

    // (GET) find studentmark by id
    @GetMapping("/studentMarks/{id}")
    ResponseEntity<StudentMarks> findStudentMarksById(@PathVariable String id){
        StudentMarks sm = studentService.getStudentById(id);
        if (sm == null){
            return new ResponseEntity<>(HttpStatus.NOT_FOUND);
        }
        else {
            return ResponseEntity.ok(sm);
        }
    }
    // (PUT) update studentmark by id

    // (DELETE) delete studentmark by id


    //////////////////////////////////
    // EX CODE FROM EMPLOYEE SERVICE
    //////////////////////////////////

//    // Return all employees
//    // GET: http://localhost:8080/api/v1/employees/
//    @GetMapping("/employees")
//    public List<Employee> getAllEmployees() {
//        return employeeService.findAllEmployees();
//    }
//
//    // Create a new employee
//    // POST: http://localhost:8080/api/v1/employees/create
//    // send this in postman: {"id": "4", "firstName": "Kyle", "lastName": "Muldoon"}
//    @PostMapping("/employees/create")
//    public Employee createEmployee(@RequestBody Employee employee) {
//        return employeeService.addEmployee(employee);
//    }
//
//    // Get a particular employee
//    // GET: http://localhost:8080/api/v1/employees/__num__
//    @GetMapping("/employees/{id}")
//    public ResponseEntity<Employee> getEmployeeById(@PathVariable(value = "id") Long employeeId) throws ResourceNotFoundException {
//        Employee employee = employeeService.getEmployeeById(employeeId)
//                .orElseThrow(() -> new ResourceNotFoundException("Employee by Id Not Found" + employeeId));
//        return ResponseEntity.ok().body(employee);
//    }
//
//    // Update a particular employee
//    @PutMapping("/employees/update/")
//    public ResponseEntity<Employee> updateEmployeeById(@RequestBody Employee employeeNew) throws ResourceNotFoundException {
//        Employee employee = employeeService.getEmployeeById(employeeNew.getId())
//                .orElseThrow(() -> new ResourceNotFoundException("Employee by Id Not Found" + employeeNew.getId()));
//
//        employee.setLastName(employeeNew.getLastName());
//        employee.setFirstName(employeeNew.getFirstName());
//
//        employeeService.updateEmployee(employee);
//
//        return ResponseEntity.ok().body(employee);
//    }
//
//
//    // Delete a particular employee
//    @DeleteMapping("/employees/remove/{id}")
//    public ResponseEntity<Employee> deleteEmployeeById(@PathVariable(value = "id") Long employeeId) throws ResourceNotFoundException {
//
//        Employee employee = employeeService.getEmployeeById(employeeId)
//                .orElseThrow(() -> new ResourceNotFoundException("Employee by Id Not Found" + employeeId));
//        employeeService.deleteEmployeeById(employee.getId());
//
//        return ResponseEntity.ok().body(employee);
//    }






}
